/*The syntax for each parse is defined by (guess what) a text string:
 *
 *  syntax_def ::= command_def { "|" command_def }
 *  command_def ::= command {argument_definition}
 *  argument_def ::= "(" { flag } ")" | text_arg "=" text_string
 *  text_string ::= string | "\"" string "\""
 *
 *As you can see, the supported argument types are text strings (quoting
 *is supported), and selector flags (select one option out of several).
 *
 *NOTES:
 *  - Don't make mistakes in synta definition -- there is no checking;
 *  - Unrecognized arguments on the input are silently ignored (to ease
 *    adding more arguments in the future);
 *  - Every command *must* be terminated by '\n', not end of file
 */  
#ifndef _PARSER_H
#define _PARSER_H

//Parse "tree" is not a tree at all. It's a structure, one of the fields
//of which points to an array of structures. Don't ask...
typedef struct {
  int   sel;
  char *text;
} argrec;

typedef struct {
  int     ID;
  argrec *argv;
  int     argn;
} treerec;

//Protos
int fdwaitr(int fd, int timeout);
treerec *fdparse(int fd, int timeout, const char *syntax);
int fdprintf(int fd, int timeout, const char *format, ...);
void free_parse_tree(treerec *tree);
void print_parse_tree(const char *syntax, treerec *tree, FILE *fp);

#endif